--
-- woz konny do zbierania skoszonych/wykopanych upraw
-- @author: Burner
--

wozkonny = {};

function wozkonny.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Trailer, specializations);
end;

function wozkonny:load(xmlFile)
	self.fillScale = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.fillScale#value"), 1);
    self.parobek = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.parobek#index"));
	self.parobek2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.parobek2#index"));
	self.parobek3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.parobek3#index"));
    self.parobekActive = false;
	self.parobek2Active = false;
	self.parobek3Active = false;
	self.collect = false;
	self.collectTypes = {};
	self.collectTypes[Fillable.FILLTYPE_UNKNOWN] = true;
	local collectTypes = getXMLString(xmlFile, "vehicle.collectTypes#fruitTypes");
	if collectTypes ~= nil then
		local types = Utils.splitString(" ", collectTypes);
		for k,v in pairs(types) do
			local collectType = Fillable.fillTypeNameToInt[v];
			if collectType ~= nil then
				self.collectTypes[collectType] = true;
			end;
		end;
	end;	
end;

function wozkonny:getSaveAttributesAndNodes(nodeIdent)
end;

function wozkonny:delete()
end;

function wozkonny:mouseEvent(posX, posY, isDown, isUp, button)
end;

function wozkonny:keyEvent(unicode, sym, modifier, isDown)
	if isDown and sym == Input.KEY_v then
		self.parobekActive = not self.parobekActive;
		self.parobek2Active = not self.parobek2Active;
		self.parobek3Active = not self.parobek3Active;
	end;
end;

function wozkonny:update(dt)
	if self:getIsActiveForInput() then
        if InputBinding.hasEvent(InputBinding.COLLECTFRUITS) then
            self.collect = not self.collect;
        end;
		if self.collect and self.fillLevel < self.capacity then
			local area = 0;
			for k, cuttingArea in pairs(self.cuttingAreas) do
				local x,y,z = getWorldTranslation(cuttingArea.start);
				local x1,y1,z1 = getWorldTranslation(cuttingArea.width);
				local x2,y2,z2 = getWorldTranslation(cuttingArea.height);
                for collectType,v in pairs(self.collectTypes) do
                    if collectType ~= Fillable.FILLTYPE_UNKNOWN then
						if self.currentFillType == collectType or self.currentFillType == Fillable.FILLTYPE_UNKNOWN then
							local fruitType = FruitUtil.fillTypeToFruitType[collectType];
							local area = Utils.updateFruitCutLongArea(fruitType, x, z, x1, z1, x2, z2, 0);
							area = area + Utils.updateFruitWindrowArea(fruitType, x, z, x1, z1, x2, z2, 0);
							if area > 0 then
								self.currentFruitType = fruitType;
								if self.currentFruitType == FruitUtil.FRUITTYPE_GRASS or self.currentFruitType == FruitUtil.FRUITTYPE_DRYGRASS then
									literPerSqm = g_strawLitersPerSqm*2;
								else
									literPerSqm = FruitUtil.fruitIndexToDesc[self.currentFruitType].literPerSqm; --* (1 + 0.50 * (3 - g_currentMission.missionStats.difficulty));
								end;
								local pixelToSqm = g_currentMission:getFruitPixelsToSqm();
								local sqm = area*pixelToSqm;
								local deltaLevel = sqm*literPerSqm*self.fillScale;
								self:setFillLevel(self.fillLevel+deltaLevel, collectType);
							end;
						end;
					end;
				end;
			end;
			if self.fillLevel == 0 then
				self.currentFruitType = FruitUtil.FRUITTYPE_UNKNOWN;
			end;
		else
			self.collect = false;
		end;
	end;
	setVisibility(self.parobek, self.parobekActive);
	setVisibility(self.parobek2, self.parobek2Active);
	setVisibility(self.parobek3, self.parobek3Active);
end;

function wozkonny:draw()
	if self.attacherVehicle ~= nil then
		if self.collect then
			g_currentMission:addHelpButtonText(g_i18n:getText("collectFruitsTurnOff"), InputBinding.COLLECTFRUITS);
		else
			g_currentMission:addHelpButtonText(g_i18n:getText("collectFruits"), InputBinding.COLLECTFRUITS);
		end;
		if self.parobekActive then
			g_currentMission:addHelpButtonText(g_i18n:getText("hideWorkers"), InputBinding.TOGGLEWORKERS);	
		else
			g_currentMission:addHelpButtonText(g_i18n:getText("showWorkers"), InputBinding.TOGGLEWORKERS);	
		end;	
	end;
end;